#ifndef EPITROCHOID_X_FO_H
#define EPITROCHOID_X_FO_H

#include <math.h>
#include "Types.h"


// Template function object class which calculates the x-coordinate
// of a point at an epitrohoid for a given parameter value t
// Parameters:
//    NumType_    the number type of the points coordinates
template <class NumType_> 
class Epitrochoid_x_FO {

public:
    typedef CGAL::Cartesian<NumType_> REP;
    typedef CGAL::Point_2<REP> Point;           
    
    Epitrochoid_x_FO(NumType_ a = 2.0, NumType_ b = 5.0, 
		     NumType_ c = 3.0) : a_(a), b_(b), c_(c) {}    

    NumType_ operator() (NumType_ t) const {	
	return ((a_+b_)*cos(t) - c_*cos((a_/b_+1.0)*t));
    }

private:    
    NumType_ a_;
    NumType_ b_;
    NumType_ c_;
};
#endif //EPITROCHOID_X_FO_H
