#ifndef TALBOT_Y_FO_H
#define TALBOT_Y_FO_H

#include <math.h>
#include "Types.h"


// Template function object class which calculates the y-coordinate
// of a point at a talbots curve for a given parameter value t
// Parameters:
//    NumType_    the number type of the points coordinates
template <class NumType_> 
class Talbots_curve_y_FO {

public:
    typedef CGAL::Cartesian<NumType_> REP;
    typedef CGAL::Point_2<REP> Point;           
    
    Talbots_curve_y_FO(NumType_ a = 10.0, NumType_ f = 1.0, NumType_ b =10.0) : a_(a), f_(f), 
	b_(b) {}

    NumType_ operator() (NumType_ t) const {
	assert(b_!=0.0);
	NumType_ f_2 =  power(f_,2);
	return (power(a_,2) -2*f_2 +f_2*power(sin(t),2))*sin(t)/b_;
    }

private:    
    NumType_ a_;    
    NumType_ f_;
    NumType_ b_;
};
#endif //TALBOT_Y_FO_H
